package WebFlow.GatewayTest;
import WebFlow.*;
import WebFlow.submitJob.*;
import WebFlow.ATD.*;
import org.w3c.dom.*;
import com.ibm.xml.parser.Parser;
import com.ibm.xml.parser.TXDocument;
import java.io.FileInputStream;
import java.io.PrintWriter;
import java.io.File;
import java.util.Vector;
import java.io.*;
import WebFlow.GatewayTest.framew;
import com.ibm.xml.parser.ExternalID;
import com.ibm.xml.parser.DTD;

public class XmlServerImpl extends BeanContextChildSupport
                           implements
WebFlow.GatewayTest.XmlServerOperations {
String msg_;
org.omg.CORBA.Object peer;
private Parser parser;
private Document doc;
public String[] piplist;
public String[] poplist;
String[] ipfiles;
String[] opfiles;
String str;


    public XmlServerImpl(org.omg.CORBA.Object peer, String msg)
        throws WebFlow.NullPointerException {

        super(peer);
        this.peer = peer;
msg_ = msg;
    }

    public void test() {
        System.out.println("XmlServer is up");
    }

    public boolean instantiateParser(String FileName) {
        boolean status = false;
        try {
            File infile = new File(FileName);
            if(infile.exists()) {
              FileInputStream is = new FileInputStream(FileName);
              parser = new Parser(FileName);
              doc = parser.readStream(is);
              if(parser.getNumberOfErrors() > 0) {
               System.out.println("Sorry, the xml document has errors");
//System.exit(1);
              }
              else {
               status = true;
              }
            }
            else {
               System.out.println("Sorry, file "+FileName+" does not exist");
            }
        } catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
        }
       return status;
    }

    public void printXML(){
try {
            ((TXDocument)doc).print(new PrintWriter(System.out));
        } catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
        }
    }

    public void testDOM(){
        try {
            Node root=doc.getDocumentElement();
            System.out.println("document: "+root.getNodeName());
            printAllTags(root);

        } catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
     }
    }

    private Node[] getApplicationNodes() {
	Node[] result = null;
	try {
		Node root = doc.getDocumentElement();
		Vector a = getAllTags(root, "application");
		int n = a.size();
		result = new Node[n];
		for (int i=0; i<n; i++) {
			result[i] = (Node)a.elementAt(i);
		}
	}
	catch (Exception e) {
		System.out.println(e+" While getApplicationNodes");
	}
	return result;
    }

    private Node selectApplicationNode (String ApplName) {
	Node[] a = getApplicationNodes();
	Node result = null;
	for (int i=0; i<a.length; i++) {
		if(((Element)a[i]).getAttribute("id").equals(ApplName)) {
			result = a[i];
			break;
			}
		}
	return result;
   }

    public String[] getInstalledHosts(String ApplName) {
      String[] hosts=null;
      try {
        Node root=selectApplicationNode(ApplName);
        Vector tags = getAllTags(root,"target");
        int n = tags.size();
        int k = 0;
        for (int i=0; i<n; i++){

if(getAttributeValue((Node)tags.elementAt(i),"status","installed") 
               .equals("Yes")){
                k++;  }
        }
        hosts = new String[k];
        int j = 0;
        for (int i=0; i<n; i++){
           Node h =(Node)tags.elementAt(i);
           if(getAttributeValue(h,"status","installed").equals("Yes")){
           hosts[j] = ((Element)h).getAttribute("id");
           j++;
           }
        }
       } catch (Exception e) {
        System.out.println(e);
        e.printStackTrace();
      }
      return hosts;
    }

public boolean isApplicationInstalled(String HostName) {
        boolean status = false;
        try {
            Node root=doc.getDocumentElement();
            System.out.println("document: "+root.getNodeName());
            String ApplicationName = ((Element)root).getAttribute("id");
            System.out.println("Application Name: "+ApplicationName);

            boolean found = false;
            Node ch = findTagWithAttribute(root,"target","id",HostName);
            if(ch != null) {
              if(getAttributeValue(ch,"status","installed").equals("Yes")){
                status=true;
              }
            }
        } catch (Exception e) {
              System.out.println(e);
e.printStackTrace();
        }

        return status;
    }


    public boolean isApplicationInstallable(String hostname) {
       boolean status = false;
         Node root=doc.getDocumentElement();
         if( ((Element)root).getAttribute("installable").equals("Yes")) {
            status = true;
         }
       return status;
    }

    public void setApplicationInstalled(String hostname) {
}


  public void getCmdLine(String hostname, String method) {

    System.out.println("getCmdLine called........");

    CmdLineEvent clEvent;
    String RSLstring="none";
    String CommandLine="";
    String Host=hostname;
    boolean script=false;

    if(method.equals("Globus")) {
       Host += "-fork";
       RSLstring=getRSL(Host);
       if (script) {
/*find_out_what_data_are_needed
           write RSL string to run the script
           fire generateScriptEvent
         */
         System.out.println("scripts are not yet supported");
       }
       else {
       clEvent = new CmdLineEventImpl(getBeanContextChildPeer());
       clEvent.setCmdLine(" ");
       clEvent.setRsl(RSLstring);
       clEvent.setHost(Host);
       fireEvent("submit",clEvent);
       }
    }
    else {
       CommandLine=getCommandLine(Host);
       if (script) {
/* find_out_waht_data_are_needed
           write command line to run the script
           fire generateScriptEvent
         */
         System.out.println("scripts are not yet supported");
       }
       else {
       clEvent = new CmdLineEventImpl(getBeanContextChildPeer());
       clEvent.setCmdLine(CommandLine);
       clEvent.setRsl("");
       clEvent.setHost(Host);
       System.out.println("ready to fire: "+CommandLine);
       fireEvent("submit",clEvent);
       System.out.println("event fired!");
       }
    }
}

public String getCommandLine(String hostname) {
      String rsl="not ready yet";
      boolean status = false;
      String command="";
        try {
            Node root=doc.getDocumentElement();
            Node ch = findTagWithAttribute(root,"target","id",hostname);
            if(ch != null) {
              if(getAttributeValue(ch,"status","installed").equals("Yes")){
                status=true;
              }
              if(status) {
                  // find node <installed>
                  Node ch1 = findFirstTag(ch,"installed");
                  // executable or a script to be generated?
Node Snode = findFirstTag(ch1,"script");
                  if(Snode == null) {
                     // retrieve CmdLine
                     Snode = findFirstTag(ch1,"CmdLine");
                     if (Snode == null) {
                       System.out.println("Oops, no CmdLine node!");
                     }
                     else {
                       command = ((Element)Snode).getAttribute("command");
                     }
                  }
                  else {
                    // there is a script to be generated
                    Node Mnode = findFirstTag(Snode,"module");
                    if(Mnode != null) {
                     rsl  = "script:";
                     rsl += "name="+((Element)Mnode).getAttribute("name");
rsl += " idl="+((Element)Mnode).getAttribute("idl");
                     rsl += "class="+((Element)Mnode).getAttribute("class");
                    }
                    else {
                     System.out.println("something fishy... no module tag");
                    }
                  }
              }
              else {
               System.out.println("Sorry, this application is not installed "+" on "+hostname);
              }
            }
        } catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
        }
return command;
    }

    public String getRSL(String hostname) {
      String rsl="not ready yet";
      boolean status = false;
      // find node "installed" and then go over all is childersn tags and
      // grab its attibute
        try {
            Node root=doc.getDocumentElement();
            Node ch = findTagWithAttribute(root,"target","id",hostname);
            if(ch != null) {
              if(getAttributeValue(ch,"status","installed").equals("Yes")){
                status=true;
              }
              if(status) {
                  // find node <installed>
Node ch1 = findFirstTag(ch,"installed");
                  // executable or a script to be generated?
                  Node Snode = findFirstTag(ch1,"script");
                  if(Snode == null) {
                     // construct RSL
                     rsl="";
                     for(Node ch2 = ch1.getFirstChild(); ch2!=null;
                                             ch2 = ch2.getNextSibling()) {
                      if(ch2 instanceof Element) {
                         rsl += ch2.getNodeName()+"=";
                         rsl +=((Element)ch2).getAttribute("file_id")+";";
                      }
                     }
                  }
                  else {
                    // there is a script to be generated
                    Node Mnode = findFirstTag(Snode,"module");
if(Mnode != null) {
                     rsl  = "script:";
                     rsl += "name="+((Element)Mnode).getAttribute("name");
                     rsl += " idl="+((Element)Mnode).getAttribute("idl");
                     rsl += "class="+((Element)Mnode).getAttribute("class");
                    }
                    else {
                     System.out.println("something fishy... no module tag");
                    }
                  }
              }
              else {
               System.out.println("Sorry, this application is not installed "+" on "+hostname);
              }
            }
        } catch (Exception e) {
System.out.println(e);
              e.printStackTrace();
        }
      return rsl;
    }


    public String getInstallRSL(String hostname) {
      String rsl="not ready yet";
      return rsl;
    }

    private String getAttributeValue(Node node, String tag, String name) {
        String value="";
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
if(ch.getNodeName().equals(tag)) {
                    value=((Element)ch).getAttribute(name);
                    break;
                 }
              }
          }
      return value;
    }

    private Node findFirstTag(Node node, String tag) {
        Node result=null;
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                    result=ch;
                    break;
}
              }
          }
      return result;
    }

    private Vector getAllTags(Node node, String tag) {
        Vector result=new Vector();
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                    result.addElement(ch);
                 }
              }
          }
      return result;
}


    private Node findTagWithAttribute(Node node, String tag,
                                      String attr, String value) {
        Node result=null;
        for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                        if(
((Element)ch).getAttribute(attr).equals(value)){
                           result=ch;
                           break;
                        }
                 }
              }
          }
return result;
    }


    private static void printAllTags(Node node){
            for(Node ch = node.getFirstChild(); ch!=null;
                ch = ch.getNextSibling()) {
                if(ch instanceof Element) {
                   System.out.println(ch.getNodeName());
                   NamedNodeMap nnm = ch.getAttributes();
                   for(int i=0;i<nnm.getLength();i++) {
                       Attr attr = (Attr)nnm.item(i);
                       String aname = attr.getNodeName();
                       String avalue = ((Element)ch).getAttribute(aname);
                       System.out.println("-"+aname+"="+avalue);
                   }
                   printAllTags(ch);
}
            }
    }

    public String createAD (String hostname) {
        str = hostname;
        try {
                Node root=doc.getDocumentElement();
                String ApplicationName =
                ((Element)root).getAttribute("id");
                System.out.println("Application Name : "+ApplicationName);
                Vector tags = getAllTags(root,"target");
                int n = tags.size();
                int k = 0;
                for (int i=0; i<n; i++) {
                Node h = (Node)tags.elementAt(i);
                if( ((Element)h).getAttribute("id").equals(hostname)){
str=hostname;
                }
                else {
                root.removeChild(h);
}
        }
}
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
        }
        return str;

}

    public String SaveAsXml (){
        System.out.println("initializaing string...");
String strg = "opfile.xml";
        System.out.println("Entered the function: SaveAsXml()");
        try {
                Node root = doc.getDocumentElement();
                ((TXDocument)doc).print(new FileWriter(strg));
        }
        catch (Exception e){
                e.printStackTrace();
        }
        System.out.println("the file name is :..." +strg);

        return "opfile.xml";
}

    public String[] GetIPFiles(String hname){
        System.out.println("function entered.......");
        Vector vlist = new Vector();
Vector pilist = new Vector();
        try{
        Node root=doc.getDocumentElement();
        Vector rtags =getAllTags(root, "target");
        int rn = rtags.size();
        for (int i=0; i<rn; i++){
                Node ch = (Node)rtags.elementAt(i);
                if( ((Element)ch).getAttribute("id").equals(hname)){
                System.out.println("host name is :...."+hname);
                NodeList list = ch.getChildNodes();
                for (int y=0; y<list.getLength(); y++){
System.out.println("lenght of children.....:"+list.getLength());
                if ((list.item(y).getNodeType()) == 1){
                if ((list.item(y).getNodeName()).equals("installed")){
                Vector tags=getAllTags(list.item(y), "input");
                int n=tags.size();
                System.out.println("the no. of files are...:"+n);
for (int j=0; j<n; j++){
                Node cch = (Node)tags.elementAt(j);
                System.out.println("node name:...."+cch.getNodeName());
                Vector ctags = getAllTags(cch, "inFile");
                Node child = (Node)ctags.elementAt(0);
        System.out.println("the sec node is...:"+child.getNodeName());
                vlist.addElement(((Element)child).getAttribute("Name"));
        System.out.println("the vec element...:"+vlist.get(j));
                pilist.addElement(((Element)child).getAttribute("Path"));
                System.out.println("partly correct....");
                        }
                }}}}}
//      Object[] ol = vlist.toArray();
//      Object[] pl = pilist.toArray();
        int j=0;
        System.out.println("the lengthof ip files....:"+vlist.size());
        ipfiles = new String[2*vlist.size()];
System.out.println("the length of ip files...:"+(2*vlist.size()));
        for (int k=0; k<(2*vlist.size()); k=k+2){
                String s = (String)pilist.get(j);
                ipfiles[k] = s;
                s = (String)vlist.get(j);
                ipfiles[k+1] = s;
                j=j+1;
        }
        }
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
        }
        return ipfiles;
}

    public String[] GetOPFiles(String hname){
Vector vlist = new Vector();
        Vector polist = new Vector();
        try{
        Node root=doc.getDocumentElement();
        Vector rtags =getAllTags(root, "target");
        int rn = rtags.size();
        for (int i=0; i<rn; i++){
                Node ch = (Node)rtags.elementAt(i);
                if( ((Element)ch).getAttribute("id").equals(hname)){
                NodeList list = ch.getChildNodes();
                for (int y=0; y<list.getLength(); y++){
                if ((list.item(y).getNodeType()) == 1){
                if ((list.item(y).getNodeName()).equals("installed")){
                Vector tags=getAllTags(list.item(y), "output");
                int n=tags.size();
                for (int j=0; j<n; j++){
Node cch = (Node)tags.elementAt(j);
                Vector ctags = getAllTags(cch, "outFile");
                Node child = (Node)ctags.elementAt(0);
                vlist.add(((Element)child).getAttribute("Name"));
                polist.add(((Element)child).getAttribute("Path"));
                        }
                }}}}}
        Object[] ol = vlist.toArray();
        Object[] ppl = polist.toArray();
        int j=0;
        opfiles = new String[2*ol.length];
        for (int k=0; k<2*ol.length; k=k+2){
                String s = (String)ppl[j];
                opfiles[k] = s;
                s = (String)ol[j];
                opfiles[k+1] = s;
                j=j+1;
}
}
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
        }
        return opfiles;
}

   public void AddIPSource(String[] s){
        try{
                Node root=doc.getDocumentElement();
        Vector rtags =getAllTags(root, "target");
        int rn = rtags.size();
        Element Source = doc.createElement("Source");
        for (int i=0; i<rn; i++){
                Node ch = (Node)rtags.elementAt(i);
NodeList list = ch.getChildNodes();
                for (int y=0; y<list.getLength(); y++){
                if ((list.item(y).getNodeType()) == 1){
                if ((list.item(y).getNodeName()).equals("installed")){
                Vector tags=getAllTags(list.item(y), "input");
                int n=tags.size();
                for (int j=0; j<n; j++){
                Node cch = (Node)tags.elementAt(j);
                cch.appendChild(Source);
                ((Element)Source).setAttribute("Host" , s[0]);
                ((Element)Source).setAttribute("Path" , s[1]);
                ((Element)Source).setAttribute("File",  s[2]);
                }}}}}
        }
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
}
}

  public void GetOPSource(String[] s){
        try{
                Node root=doc.getDocumentElement();
        Vector rtags =getAllTags(root, "target");
        int rn = rtags.size();
        Element Source = doc.createElement("Source");
        for (int i=0; i<rn; i++){
                Node ch = (Node)rtags.elementAt(i);
                NodeList list = ch.getChildNodes();
                for (int y=0; y<list.getLength(); y++){
                if ((list.item(y).getNodeType()) == 1){
                if ((list.item(y).getNodeName()).equals("installed")){
                Vector tags=getAllTags(list.item(y), "output");
                int n=tags.size();
for (int j=0; j<n; j++){
                Node cch = (Node)tags.elementAt(j);
                cch.appendChild(Source);
                ((Element)Source).setAttribute("Dest" , s[0]);
                ((Element)Source).setAttribute("Path" , s[1]);
                ((Element)Source).setAttribute("File", s[2]);
                }}}}}
        }
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
        }
}

 public void descriptorGD(String filename){
        String Fname=filename;
        boolean result=false;
int idx= Fname.indexOf(".xml");
         String Name=Fname.substring(0, idx);
         System.out.println(Name);


 try{
            //creates a Document object;
       Document doc =
(Document)Class.forName("com.ibm.xml.parser.TXDocument").newInstance();

       //mkaes the "TaskDescriptor" element as the root, and adds it.
       Element root = doc.createElement("TaskDescriptor");

       //Makes the "TaskName" element, and adds it
       Element item= doc.createElement("TaskName");
       item.setAttribute("name",Name);
       item.appendChild(doc.createTextNode("Parssim code"));
root.appendChild(item);

       //Makes the "application" element with an attribute, and adds it.
       item= doc.createElement("application");
       item.setAttribute("descriptor",Fname);
       root.appendChild(item);

//Make the "connection" element with "input" & "output" elements, and adds

       item= doc.createElement("connection");

//Make the "input" element with two attribute, and adds it to connection
       Element itemChild=doc.createElement("input");

itemChild.setAttribute("application","npac/home/huapt/CASC2D/casc2d.pl");
       itemChild.setAttribute("method","input.in");
       item.appendChild(itemChild);
root.appendChild(item);

//Make the "output" element with two attribute, and adds it to connection

       itemChild=doc.createElement("output");

itemChild.setAttribute("application","npac/home/huapt/CASC2D/lms/");
       itemChild.setAttribute("event","output.out");
       item.appendChild(itemChild);

              //create the command
       //doc.appendChild(doc.createComment("DOCTYPE application SYSTEM"));
      //add the root
       DTD dt=((TXDocument)doc).createDTD("TaskDescriptor", new
ExternalID("descriptorDTD.dtd"));
      ((TXDocument)doc).appendChild(dt);
       doc.appendChild(root);
// Shows the XML document
       ((TXDocument)doc).setVersion("1.0");
        ((TXDocument)doc).printWithFormat(new FileWriter("ATDtest.xml"));
result=true;

      }
     catch(Exception e)
     {
     e.printStackTrace();
     }
 };

}

